<template>
	<f7-page name="financialreportform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Transaksi</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Transaksi</f7-nav-title-large>
		</f7-navbar>
		<f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
			<h3 class="no-margin">Penting!</h3>
			<p>Laporkan bukti pembayaran iuran wajib/donasi anda dengan mengisi formulir di bawah ini.</p>
		</f7-block>
		<f7-block class="no-margin">
			<div class="uploader margin-medium-bottom">
                <div v-if="financialreport && financialreport.medias && financialreport.medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in financialreport.medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.medium})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Bukti Bayar</span>
                        </a>
                    </div>
                </div>
                <div v-else-if="medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.original})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Bukti Bayar</span>
                        </a>
                    </div>
                </div>
                <div v-else class="uploader-item">
                    <a class="text-align-center add-image" href="#" @click="handleUpload">
                        <f7-icon f7="add" size="50"></f7-icon>
                        <span class="display-block">Bukti Bayar</span>
                    </a>
                </div>
            </div>	
		</f7-block>
		<f7-list no-hairlines class="no-margin">						
			<f7-list-input
				ref="title"
				label="Judul transaksi"
				placeholder="Ketik judul transaksi"
				maxlength="255"
				clear-button
				:value="financialReportForm.title"
				@input="financialReportForm.title = $event.target.value">
			</f7-list-input>	
			<f7-list-input
				ref="note"
				type="textarea"
				label="Catatan"
				placeholder="Ketik catatan"
				resizable					
				:value="financialReportForm.note"
				@input="financialReportForm.note = $event.target.value">
			</f7-list-input>
			<f7-list-item title="Kategori" smart-select :smart-select-params="{'closeOnSelect': true}">
				<select 
					ref="category" 
					name="category" 
					:value="financialReportForm.category"
					@change="financialReportForm.category = $event.target.value">
					<option
						v-for="item in financialReportCategories" 
						:value="item.id"
						v-bind:key="item.id">{{ convertAmpersand(item.name) }}</option>
				</select>
			</f7-list-item>
		</f7-list>
		<f7-list inline-labels no-hairlines class="no-margin-top border-separator-top">
			<f7-list-input
				class="align-right"
				label="Periode"
				type="datepicker"
				placeholder="Pilih Tanggal"
				formatValue="YYYY-MM-DD"
				readonly
				:value="[financialReportForm.period]"
				:calendar-params="{
					'closeOnSelect': true,
					monthNames: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
					monthNamesShort: ['Jan', 'Feb', 'Mar', 'Apr', 'Mei', 'Jun', 'Jul', 'Agu', 'Sep', 'Okt', 'Nov', 'Des'],
					dayNames: ['Minggu', 'Senin', 'Selasa', 'Rabu', 'Kamis', 'Jumat', 'Sabtu'],
					dayNamesShort: ['Min', 'Sen', 'Sel', 'Rab', 'Kam', 'Jum', 'Sab'],
				}"
				@change="financialReportForm.period = $event.target.value"
			></f7-list-input>
			<f7-list-input
				class="align-right"
				label="Nominal"
				type="number"
				placeholder="Rp 0"
				:value="financialReportForm.nominal"
				@input="financialReportForm.nominal = $event.target.value"
			></f7-list-input>						
		</f7-list>
		<f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Kirim</f7-button>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, dateFormat, convertAmpersand } from '../js/utils';
import { setTimeout } from 'timers';
export default {
	name: 'FinancialReportForm',
	data(){
		return{
			formType: 'Buat',
			financialReportForm: {
				id: null,
				title: '',
				trx_type: 'credit',
                category: null,
                period: new Date(),
                nominal: 0,
                note: '',
				residential: null,
                status: 'waiting',
                author: null,
				medias: []
			},
			medias: []
		}
	},
	computed: {
		...mapGetters('auth', ['user']),
		...mapGetters('category', ['financialReportCategories']),
		...mapGetters('financialreport', [
			'financialreport'
		])
	},
	methods: {
		dateFormat,
		convertAmpersand,
		getCategories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('category/getCategories', {
				module: 'financialreport',
				page: 1,
				perpage: 25,
				only: 'id,name,slug'
			});
		},
		onPageBeforeIn(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = $$(self.$el);

			if(self.$f7route.params && self.$f7route.params.id){
				self.formType = 'Ubah';
				self.financialReportForm.id = self.$f7route.params.id;
			
				app.preloader.show('green');

				self.$store.dispatch('financialreport/viewFinancialReport', {
					id: self.financialReportForm.id,
					only: 'id,number,title,note,recepient,trx_type,status,credit,debit,period,balance,created,updated,category.id,category.name,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
				}).then((response) => {
					
					self.financialReportForm.title = self.financialreport.title;
					self.financialReportForm.trx_type = 'credit';
                    self.financialReportForm.category = self.financialreport.category.id.toString();
                    self.financialReportForm.period = new Date(self.financialreport.period);
                    self.financialReportForm.nominal = self.financialreport.trx_type == 'debit' ? self.financialreport.debit : self.financialreport.credit;
                    self.financialReportForm.note = self.financialreport.note != null ? self.financialreport.note : '';
                    self.financialReportForm.author = self.user.id;
                    self.financialReportForm.residential = self.user.residential.id;

					setTimeout(()=>{
						$el.find('select').find('option[value="'+self.financialreport.category.id+'"]').prop('selected', true).trigger('change'); 
					},100);

					app.preloader.hide();
				});
			}else{
				self.financialReportForm.author = self.user.id;
				self.financialReportForm.residential = self.user.residential.id;
			}

			self.getCategories();
        },
        onPageBeforeOut(page){
            const self = this;
			const app = self.$f7;

			if(page.detail.name == 'financialreportform'){
				self.financialReportForm = {
					id: null,
					title: '',
					trx_type: 'credit',
					category: null,
					period: new Date(),
					nominal: 0,
					note: '',
					residential: null,
					status: 'waiting',
					author: null,
					medias: []
				};

				self.medias = [];
				self.formType = 'Buat';
			}			
        },
		doSubmit(e, status){
			const self = this;
			const app = self.$f7;

			if(self.financialReportForm.title.trim().length == 0){
				app.dialog.alert('Judul transaksi wajib diisi', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/.test(self.financialReportForm.title) == false){
				app.dialog.alert('Judul transaksi hanya boleh diisi dengan dengan huruf, angka, tanda minus, tanda kurung tanda plus, garis miring, titik, koma dan spasi.', 'RingSatu');
				return false;
			}else if(self.financialReportForm.category == null){
				app.dialog.alert('Kategori transaksi wajib diisi', 'RingSatu');
				return false;
			}else if(self.financialReportForm.period == null){
				app.dialog.alert('Periode transaksi wajib diisi', 'RingSatu');
				return false;			
			}else if(/^([0-9]+)$/.test(self.financialReportForm.nominal) == false){
				app.dialog.alert('Masukkan angka pada nominal', 'RingSatu');
				return false;
			}else if(self.financialReportForm.nominal == 0){
				app.dialog.alert('Nominal wajib diisi', 'RingSatu');
				return false;
			}

			app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'financialreport/editFinancialReport';
			}else{
				action = 'financialreport/createFinancialReport';
			}

			params.title = self.financialReportForm.title;
			params.trx_type = self.financialReportForm.trx_type;
			params.category = parseInt(self.financialReportForm.category);
			params.period = self.financialReportForm.period;
			params.nominal = parseInt(self.financialReportForm.nominal);
			params.note = self.financialReportForm.note;
			params.author = self.user.id;
			params.status = 'publish';
			params.medias = self.financialReportForm.medias;
			params.only = 'id,number,title,note,recepient,trx_type,status,credit,debit,period,balance,created,updated,category.id,category.name,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'

			self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
		},
		handleMediaDelete(e, imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				if(self.formType == 'Ubah'){
					self.$store.dispatch('media/deleteMedia', {
						id: parseInt(imageId),
						endpoint: 'financialreport'
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}else{
					self.$store.dispatch('media/deleteTmpMedia', {
						id: parseInt(imageId),
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}
			})
		},
		handleUpload(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = self.$el;
		
			var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/financialreport/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            
                                            if(self.formType == 'Ubah'){
                                                self.financialreport.medias.push(response.data.media);
                                            }else{
                                                self.financialReportForm.medias.push(response.data.media.id);
                                                self.medias.push(response.data.media);
                                            }
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/financialreport/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        if(self.formType == 'Ubah'){
                                            self.financialreport.medias.push(response.data.media);
                                        }else{
                                            self.financialReportForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                        }

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
		}
	},
	
}
</script>
